%define	major	20
%define	libname	%mklibname %{name} %{major}
%define	devname	%mklibname %{name} -d

%bcond_without	uclibc

Summary:	GNU Pth - GNU Portable Threads
Name:		pth
Version:	2.0.7
Release:	11
License:	LGPLv2+
Group:		System/Libraries
URL:		http://www.gnu.org/software/pth/
Source0:	ftp://ftp.gnu.org/pub/gnu/pth/%{name}-%{version}.tar.gz
Source1:	ftp://ftp.gnu.org/pub/gnu/pth/%{name}-%{version}.tar.gz.sig
Patch0:		pth-2.0.0-pth-config.in.patch
Patch1:		pth-2.0.7-linux3.patch
%if %{with uclibc}
BuildRequires:	uClibc-devel >= 0.9.33.2-15
%endif

%description
Pth is a very portable POSIX/ANSI-C based library for Unix platforms
which provides non-preemptive priority-based scheduling for multiple
threads of execution ("multithreading") inside server applications.
All threads run in the same address space of the server application,
but each thread has it's own individual program-counter, run-time
stack, signal mask and errno variable.

%package -n	%{libname}
Summary:	GNU Pth - GNU Portable Threads
Group:		System/Libraries

%description -n %{libname}
Pth is a very portable POSIX/ANSI-C based library for Unix platforms
which provides non-preemptive priority-based scheduling for multiple
threads of execution ("multithreading") inside server applications.
All threads run in the same address space of the server application,
but each thread has it's own individual program-counter, run-time
stack, signal mask and errno variable.

This package provides the main %{name} library.

%package -n	uclibc-%{libname}
Summary:	GNU Pth - GNU Portable Threads
Group:		System/Libraries

%description -n uclibc-%{libname}
Pth is a very portable POSIX/ANSI-C based library for Unix platforms
which provides non-preemptive priority-based scheduling for multiple
threads of execution ("multithreading") inside server applications.
All threads run in the same address space of the server application,
but each thread has it's own individual program-counter, run-time
stack, signal mask and errno variable.

This package provides the main %{name} library.

%package -n	%{devname}
Summary:	GNU Pth - GNU Portable Threads (Headers and Static Libs)
Group:		Development/C
Requires:	%{libname} = %{version}
%if %{with uclibc}
Requires:	%{libname} = %{version}
%endif
Provides:	%{name}-devel = %{version}-%{release}
Obsoletes:	%mklibname %{name} 20 -d
Provides:	%mklibname %{name} 20 -d

%description -n	%{devname}
Pth is a very portable POSIX/ANSI-C based library for Unix platforms.

This package provides all necessary files to develop or compile any
applications or libraries that use %{name} library.

%prep
%setup -q
%patch0 -p1 -b .cflags-ldflags~
%patch1 -p1 -b .linux3~

%build
CONFIGURE_TOP="$PWD"
%if %{with uclibc}
mkdir -p uclibc
pushd uclibc
%uclibc_configure \
		--enable-optimize=yes \
		--enable-pthread=no
%make pth_p.h
%make
popd
%endif

mkdir -p system
pushd system
CFLAGS="%{optflags} -Ofast" \
%configure2_5x	--enable-optimize=yes \
		--enable-pthread=no
	
# (tpg)	without this parallel make fails
%make pth_p.h
%make
popd

%check 
make -C system test

%install
%if %{with uclibc}
%makeinstall_std -C uclibc
mkdir -p %{buildroot}%{uclibc_root}/%{_lib}
mv %{buildroot}%{uclibc_root}%{_libdir}/libpth.so.%{major}* %{buildroot}%{uclibc_root}/%{_lib}
ln -srf %{buildroot}%{uclibc_root}/%{_lib}/libpth.so.%{major}.*.* %{buildroot}%{uclibc_root}%{_libdir}/libpth.so

rm -r %{buildroot}%{uclibc_root}%{_bindir}
%endif

%makeinstall_std -C system
mkdir -p %{buildroot}/%{_lib}
mv %{buildroot}%{_libdir}/libpth.so.%{major}* %{buildroot}/%{_lib}
ln -srf %{buildroot}/%{_lib}/libpth.so.%{major}.*.* %{buildroot}%{_libdir}/libpth.so

%files -n %{libname}
/%{_lib}/libpth.so.%{major}*

%if %{with uclibc}
%files -n uclibc-%{libname}
%{uclibc_root}/%{_lib}/libpth.so.%{major}*
%endif

%files -n %{devname}
%doc AUTHORS ChangeLog NEWS PORTING README THANKS
%{_bindir}/pth-config
%{_datadir}/aclocal/pth.m4
%{_includedir}/pth.h
%{_libdir}/libpth.a
%{_libdir}/libpth.so
%if %{with uclibc}
%{uclibc_root}%{_libdir}/libpth.a
%{uclibc_root}%{_libdir}/libpth.so
%endif
%{_mandir}/man?/*


%changelog
* Mon Oct 29 2012 Per Øyvind Karlsen <peroyvind@mandriva.org> 2.0.7-11
+ Revision: 820321
- drop multiarch workaround, there's already a patch fixing it in place..
- move library under /%%{_lib}
- do uclibc build
- compile with -Ofast
- drop bogus 'lib%%{name}-devel' provides
- cleanups

* Mon Oct 01 2012 Alexander Khrukin <akhrukin@mandriva.org> 2.0.7-10
+ Revision: 818082
- rel up
- pth-2.0.7-linux3.patch added
- pth-2.0.7-linux3.patch see https://bugzilla.redhat.com/show_bug.cgi?id=744740

* Mon May 02 2011 Oden Eriksson <oeriksson@mandriva.com> 2.0.7-9
+ Revision: 661715
- multiarch fixes

* Fri Dec 03 2010 Oden Eriksson <oeriksson@mandriva.com> 2.0.7-8mdv2011.0
+ Revision: 607236
- rebuild

* Tue Mar 16 2010 Oden Eriksson <oeriksson@mandriva.com> 2.0.7-7mdv2010.1
+ Revision: 521159
- rebuilt for 2010.1

* Thu Sep 03 2009 Christophe Fergeau <cfergeau@mandriva.com> 2.0.7-6mdv2010.0
+ Revision: 426788
- rebuild

* Thu Feb 26 2009 Tomasz Pawel Gajc <tpg@mandriva.org> 2.0.7-5mdv2009.1
+ Revision: 345284
- rebuild

* Wed Jun 18 2008 Thierry Vignaud <tv@mandriva.org> 2.0.7-4mdv2009.0
+ Revision: 225114
- rebuild
- kill re-definition of %%buildroot on Pixel's request

  + Pixel <pixel@mandriva.com>
    - do not call ldconfig in %%post/%%postun, it is now handled by filetriggers

  + Olivier Blin <blino@mandriva.org>
    - restore BuildRoot

* Thu Oct 18 2007 Tomasz Pawel Gajc <tpg@mandriva.org> 2.0.7-3mdv2008.1
+ Revision: 99795
- disable pthreads this fixes bug #34868

* Wed Oct 17 2007 Tomasz Pawel Gajc <tpg@mandriva.org> 2.0.7-2mdv2008.1
+ Revision: 99575
- fix parallel compiling
- drop patch 2
- fix file list
- new devel library policy
  compile with pthreads
  spec file clean


* Thu Feb 15 2007 Tomasz Pawel Gajc <tpg@mandriva.org> 2.0.7-1mdv2007.0
+ Revision: 121276
- new version
- drop patch 3
- spec file clean
- Import pth

* Tue Sep 06 2005 Gwenole Beauchesne <gbeauchesne@mandriva.com> 2.0.3-3mdk
- fix yet another abelism, continuously boring thing

* Thu Feb 03 2005 Abel Cheung <deaddog@mandrake.org> 2.0.3-2mdk
- multiarch

* Wed Dec 22 2004 Abel Cheung <deaddog@mandrakesoft.com> 2.0.3-1mdk
- New release 2.0.3

* Fri Nov 26 2004 Abel Cheung <deaddog@mandrake.org> 2.0.2-1mdk
- New version
- Use tar.gz (for signature checking)

* Thu May 20 2004 Abel Cheung <deaddog@deaddog.org> 2.0.0-2mdk
- Update Patch1 to not print -L/usr/lib for $ldflags
- Patch3: Automake 1.8 compatibility (quote names properly in AC_DEFUN)
- Please use UTF-8 rather than other encoding for spec!

